#!/usr/bin/php -q
<?php
	/**
	 * PHPLIST AUTO RESPONDER v1.0.0a
	 * This is a plugin for phplist
	 * Created by SaWey (C) 2007
	 *
	 *
	 * The only thing you have to do is
	 * Put the files in your root directory
	 * Then you have to set up an email forwarder to this script
	 * in the form of: |"/home/(username)/public_html/lists/autorespond.php" list_id
	 * and REPLACE the list_id with the actual list id.
	 * 
	 * You can change the messages that will be sent in autorespond_tpl.php
	 * Please keep the footer as is.
	 * The licence of this script will always be the same as the phpList licence.
	 *
	 *
	 * WHAT DOES IT DO:
	 * You can use this to let users subscribe, unsubscribe and confirm subscription by mail.
	 * 
	 * HOW TO:
	 * Send an email to the configured forward address, with as subject:
	 * 'SUBSCRIBE' to subscribe to the list
	 * 'UNSUBSCRIBE -uniqueid' to unsubscribe to the list
	 * 'CONFIRM -uniqueid' to confirm a subscription.
	 *
	 *
	 */

	$list_id = $_SERVER[argv][1];//get params
	//$list_id = 3;
	//$fd = fopen("testmail", "r");
	$fd = fopen("php://stdin", "r"); // read from stdin
	$email = "";
	while (!feof($fd)) {
		$email .= fread($fd, 1024);
	}
	fclose($fd);
	// handle email
	
	$lines = explode("\n", $email);
	
	// empty vars
	$from 	 = "";
	$to 	 = "";
	$subject = "";
	$headers = "";
	$message = "";
	$unid	 = 0;
	$user_id = 0;
	$splittingheaders = true;
	
	for ($i=0; $i < count($lines); $i++) {
		if ($splittingheaders) {
			// this is a header
			$headers .= $lines[$i]."\n";
	
			// look out for special headers
			if (preg_match("/^Subject: (.*)/", $lines[$i], $matches)) {
				$subject = strtoupper(trim($matches[1]));
				$epl = explode("-", $subject);
				if(trim($epl[0]) == 'CONFIRM'){
					$subject = trim($epl[0]);
					$unid = trim($epl[1]);
				}elseif(trim($epl[0]) == 'UNSUBSCRIBE'){
					$subject = trim($epl[0]);
					$unid = trim($epl[1]);
				}
			}
			if (preg_match("/^From: (.*)/", $lines[$i], $matches)) {
				preg_match("/[\._a-zA-Z0-9-]+@[\._a-zA-Z0-9-]+/i", $matches[1], $f_email);
				$from = $f_email[0];
			}
			if (preg_match("/^To: (.*)/", $lines[$i], $matches)) {
				preg_match("/[\._a-zA-Z0-9-]+@[\._a-zA-Z0-9-]+/i", $matches[1], $t_email);
				$to = $t_email[0];
			}
		} else {
			break;
		}
	
		if (trim($lines[$i])=="") {
			// empty line, header section has ended
			$splittingheaders = false;
		}
	}

	//Require some files
	include_once "./config/config.php"; 
	require_once "./admin/commonlib/lib/magic_quotes.php"; 
	require_once "./admin/init.php"; 
	require_once "./admin/".$GLOBALS["database_module"]; 
	require_once "./admin/defaultconfig.inc"; 
	require_once "./texts/dutch.inc";
	include_once "./texts/".$GLOBALS["language_module"];
	require_once "./admin/connect.php"; 
	include_once "./admin/languages.php"; 
	include_once "./admin/lib.php"; 
	include_once "./admin/defaultconfig.inc"; 
	include_once "./admin/mysql.inc"; 
	include_once "./admin/commonlib/lib/userlib.php";
	include_once "./autorespond_tpl.php";
	
	switch($subject){
		case 'SUBSCRIBE':
			//Add user to db
			//check if user exists
			$sql = "SELECT id FROM ".$usertable_prefix."user WHERE email='".addslashes($from)."'";
			$result = Sql_Fetch_Array_Query($sql);
			
			if(isset($result['id'])){
				//user exists
				$user_id = $result['id'];
				
				//subscribe to list
				$result = Sql_query("REPLACE INTO ".$GLOBALS["tables"]["listuser"]." (userid,listid,entered) VALUES(".$user_id.", ".$list_id.", now())");
		
				//add little message to history
				addUserHistory($from,"Automated subscription by mail","User subscribed to: " . listName($list_id));
				
				//send status update mail
				$user_unid = reqUniqueId($user_id);
				$unsubscribeurl = ereg_replace('\[WEBSITE\]', $GLOBALS["website"], $GLOBALS['default_config']['unsubscribeurl'][0]) . '&uid=' . $user_unid;
				$preferencesurl = ereg_replace('\[WEBSITE\]', $GLOBALS["website"], $GLOBALS['default_config']['preferencesurl'][0]) . '&uid=' . $user_unid;
				$confirmmessage	= ereg_replace('\[LISTS\]', listName($list_id), $confirm_message);
				$confirmmessage = ereg_replace('\[PREFERENCESURL\]', $preferencesurl, $confirmmessage);
				$confirmmessage = ereg_replace('\[UNSUBSCRIBEURL\]', $unsubscribeurl, $confirmmessage);
				$confirmmessage = ereg_replace('\[REPLY\]', $to, $confirmmessage);
				$confirmmessage = ereg_replace('\[UNID\]', $user_unid, $confirmmessage);
				
				$confirm_subj = getConfig("confirmationsubject:".$list_id);
				sendMail($from, $confirm_subj, $confirmmessage, system_messageheaders($from), $envelope, 1);	
				
			}else{
				//user doesn't exist, add to db
				$user_id = addNewUser($from);
				
				//add little message to history
				addUserHistory($from,"Automated subscription by mail","User added by sending an email to " . $to);
				
				//subscribe user to list
				$result = Sql_query("REPLACE INTO ".$GLOBALS["tables"]["listuser"]." (userid,listid,entered) VALUES(".$user_id.", ".$list_id.", now())");
		
				//add little message to history
				addUserHistory($from,"Automated subscription by mail","User subscribed to: " . listName($list_id));
				
				//request activation
				$user_unid = reqUniqueId($user_id);
				$confirmationurl = ereg_replace('\[WEBSITE\]', $GLOBALS["website"], $GLOBALS['default_config']['confirmationurl'][0]) . '&uid=' . $user_unid;
				$subscribemessage = ereg_replace('\[LISTS\]', listName($list_id), $subscribe_message);
				$subscribemessage = ereg_replace('\[CONFIRMATIONURL\]', $confirmationurl, $subscribemessage);
				$subscribemessage = ereg_replace('\[UNID\]', $confirm_id, $subscribemessage);
				$subscribemessage = ereg_replace('\[REPLY\]', $to, $subscribemessage);
				
				
				$subscr_subj = getConfig("subscribesubject:".$list_id);
				sendMail($from, $subscr_subj, $subscribemessage, system_messageheaders($from), $envelope, 1);	

			}
			break;
		case 'CONFIRM':
			//confirm the user with uniqid = $unid
			$result = Sql_query("UPDATE " . $GLOBALS["tables"]["user"] . " SET confirmed = 1 WHERE uniqid = '" . strtolower($unid) . "'");
			
			//send mail as confirmation
			if($result){
				sendMail($from, getConfig("confirmationsubject:".$list_id), $confirmationmessage,system_messageheaders(),$envelope);
			}else{
				//send an email to tell we didn't receive a good uniqid
				sendError($from, system_messageheaders(), $envelope, $error_subject_invalid_unid);
			}
			$adminmessage = $userdata["email"] . " has confirmed their subscription";
			if ($blacklisted) {
				$adminmessage .= "\nUser has been removed from blacklist";
			}
			sendAdminCopy("List confirmation",$adminmessage);
			addSubscriberStatistics('confirmation',1);
			
			break;
		case 'UNSUBSCRIBE':
			//unsubscribe the user from this list
			$query = Sql_Fetch_Row_Query("SELECT id,email FROM " . $GLOBALS["tables"]["user"] . " WHERE uniqid = '" . strtolower($unid) . "'");
			if(isset($query[1])){
				$userid = $query[0];
				$email = $query[1];
				$result = Sql_query("DELETE FROM " . $GLOBALS["tables"]["listuser"] . " WHERE userid = '" . $user_id . "'");
				//add user to blacklist
			    addUserToBlacklist($email,"Unsubscribed by mail");
			    addUserHistory($email,"Unsubscription","Unsubscribed from " . listName($list_id));	
				$subscribeurl = ereg_replace('\[WEBSITE\]', $GLOBALS["website"], $GLOBALS['default_config']['subscribeurl'][0]);
				$unsubscribemessage = ereg_replace('\[SUBSCRIBEURL\]', $subscribeurl, $unsubscribe_message);
					
					
				sendMail($email, getConfig("unsubscribesubject"), stripslashes($unsubscribemessage), system_messageheaders($email));
			    sendAdminCopy("List unsubscription",$email . " has unsubscribed by mail");		
			}else{
				//send an email to tell we didn't receive a good uniqid
				sendError($from, system_messageheaders(), $envelope, $error_subject_invalid_unid);
			}
			break;
		default:
			//send message that we didn't know what he/she wanted to do
			sendError($from, system_messageheaders(), $envelope, $error_subject_invalid_command);
			break;
	
	}
	
	function reqUniqueId($id) {
	  	$req = Sql_Fetch_Row_Query('SELECT uniqid FROM ' . $GLOBALS["tables"]["user"] . ' WHERE id = '.$id);
	  	return stripslashes($req[0]);
	}
	
	function sendError($from, $system_messageheaders, $envelope, $answer){
		if(strlen($unid) > 1){
			$subject .= ' -';
		}
		$req = ($subject . $unid);
		$errormessage = ereg_replace('\[REQUEST\]', $req, $error_message);
		$errormessage = ereg_replace('\[ANSWER\]', $answer, $errormessage);
		sendMail($from, $answer, $errormessage, $system_messageheaders, $envelope);	
		
		//log it to database
		logEvent("Error on email command: ".$error_message,0,150));
	}
	
?>
